PDA - Extranet Uploader

Extranet Uploader Application

The Extranet Uploader adds the ability to automate the process of uploading documents to cloud based collaboration portals.

The application is based on a project approach, where multiple extranet definitions can be configured per project.

Upload requests are made by selecting one or more files in the vault, then selecting which extranet definition should be used to process those files. Submitted upload requests are processed sequentially by the M-Files server. Users can view the request log from either a project or document context within the M-Files desktop application. The log interface shows all requests and their current status e.g. Queued, In Progress, Successful or Failed.

Pentagon Help resources:

Pentagon Product Help

PentagonDocs Assistant

PentagonMail Assistant

Help for specific Applications: (these will open in a new browser window)

Core Script Library

DWG Processor

Extranet Uploader (you are here)

Notifications Processor

PDF Processor

Transmittals

Copyright © Pentagon Solutions Ltd. All Rights Reserved.


Supported Providers

The Extranet Uploader currently supports the following providers. If the provider you require is not listed, please contact Pentagon .

Adoddle

Asite's Adoddle helps people manage their projects and supply chains collaboratively, accessing the information they need, when and where they need it. It enables AEC companies to measure and track capital projects and asset operations.

BIM 360 Document Management

Autodesk BIM 360 Docs is a construction document management solution offering cloud-based and desktop tools and services. Publish, manage, review and approve project plans, models and documents from the earliest phase of a project through owner occupancy.

Dropbox

Dropbox is a personal cloud storage service for storing, sharing and synchronizing files.

Google Drive

Google Drive is a file storage and synchronization service allowing users to store files and synchronize them across multiple devices.

SharePoint Online

SharePoint is a web based collaboration platform offering and functions as a storage system and document management system

Viewpoint For Projects

Viewpoint for Projects is a cloud-based document and information management solution for sharing, controlling and collaborating on project documents with dispersed project teams.

WeTransfer

WeTransfer is an internet based file transfer service.


Known Issues and Limitations

Asite Adoddle

Logging In

By default, the login account provided by Asite does not have API access granted. The Adoddle extranet provider uses the Asite API to communicate with Adoddle.

Without API access, attempts to login when configuring an Adoddle extranet definition will fail.

Please contact Asite to get API access granted on your account.

Multiple File Types

Adoddle does not allow multiple file types with the same name to exist in the same folder. The primary Doc Ref does not include a file extension, and treats all uploads with the same name (excluding filename) as the same document. Attempts to upload a native file and a rendition to the same folder in Adoddle will result in only one document appearing on the site.

The file type icon displayed in Adoddle is determined by which file was uploaded last.

All files are reported as being successfully uploaded by the Extranet Uploader. However, the different file formats are treated as versions of the same document. This can be seen when interrogating the history of the document in Adoddle. The history shows that a DWG and PDF file have been uploaded.

Autodesk BIM 360 Docs

Forge API Restrictions

The Autodesk Forge API does not currently support access to custom attributes defined on the site. Because of this, we are currently unable to synchronise meta data beyond that of the filename.

We hope to support this functionality as soon as Autodesk make it available.

Also See

Adoddle (Asite) Definition Settings

Autodesk BIM 360 Definition Settings


Prerequisites

Before installing the Extranet Uploader on your M-Files Server, please ensure the prerequisites listed below have been met.

  • M-Files Server 2018 (12.0.6550.8) or above
  • Microsoft .NET Framework 4.7.2 or above
  • Extranet Uploader License File


Server Installation

NOTE: The application will need to be licensed before users are able to upload documents.

Also See

Licensing


Client Installation

Installation ››

Client Installation

Once the Server Installation is complete, the Application will be pushed out to the clients automatically by the server, on next logon.

To verify if clients have the application, press ALT in M-Files, then using the top menu, go to Settings, Applications.

If it's missing then logout, or restart the machine.

NOTE: The application will need to be licensed before users are able to upload documents.


Licensing

Before you can use the Extranet Uploader, you need to install a valid license. Without a valid license, all upload requests will fail due to a license error. A license file can be obtained from Pentagon and is linked to the M-Files installation via the M-Files License Serial Number (xxx-xxxxxxxx).

After installation, the Application has a status of 'No license is installed'. Each vault with the Extranet Uploader installed will need to have a license added. The same license file can be used across multiple vaults on the same M-Files server.


Default Settings

The Default settings allow the configuration of the 'BaseObjectType' on which the Extranet Processor will be available.

To access the default settings launch the Pentagon DOCS Administration Utility

If this is the first time launching the Utility you will be prompted to select which MFiles Vault you wish to connect to, once connected navigate to the Extranet Settings

Upon selection of this tab, you are presented with configuration options as shown below.

To make changes to these settings, click the Edit button in the bottom right corner.

Default Settings - Base Object Type

Base Object Type | Select the Object Type on which the Extranet Processor should be available, the default object is Project
Clear | This will remove all extranet settings from the current vault


Asite Adoddle Integration

No pre-configuration setup is required for Asite Adoddle.

Please continue to the Asite Adoddle Configuration page to get started

Also See

Known Issues and Limitations


Autodesk BIM 360 Integration

Before you can create a BIM 360 Docs extranet definition, your BIM 360 administrator will need to add the Pentagon DOCS custom integration to your site. The custom integration is required to grant access to your data from the Extranet Uploader. https://docs.b360.autodesk.com/

To do this, navigate to 'Account Admin' page, select the 'SETTINGS' heading and 'Custom Integrations' sub menu.

Click the 'Add Custom Integration' button. Check the 'Document Management' option and click 'Next'.

Select the 'Invite a developer' option, then enter the following email address: support@pentagonsolutions.com

Lastly, click 'Send'.

The custom integration will be listed as 'Invitation has been sent to dms.forge@Pentagon.co.uk' as shown below.

When Pentagon receive the invitation, the custom integration can be configured for your BIM 360 site.

Once this has been completed, the custom integration requires your BIM 360 Administrator to approve the custom integration.

Simply click the 'Approve' button to allow the Pentagon DOCS custom integration access to your site.

The custom integration is now showing as 'Active'. Users of Extranet Uploader will now be able to create BIM 360 Docs extranet definitions.

Next step:

Continue to Autodesk BIM 360 Configuration step

Also See

Known Issues and Limitations


Dropbox API Integration

Before you can create a Dropbox extranet definition, you or your Dropbox administrator will need to generate Dropbox API credentials for the PentagonDocs Extranet Uploader.

These credentials are required to grant access to your data from the Extranet Uploader.

To do this, login to your Dropbox account here: https://www.dropbox.com/developers/apps/create

  1. Choose an API = Scoped Access
  2. Choose the type of access you need = Full Dropbox
  3. Name your app = enter a suitable name

Then click 'Create app'

On the next screen choose the Permissions tab and ensure the following items are selected

  1. files.metadata.write
  2. files.metadata.read (this will be greyed out and is normal)
  3. files.content.write
  4. files.content.read
  5. sharing.write
  6. sharing.read (this will be greyed out and is normal)

Ensure you click the Submit button at the bottom of the screen to apply these settings

Select the Settings tab and ensure that Access token expiration is set to No expiration, with this enabled click Generate

The access token will be displayed

Copy this generated access token, as it is required for the next step: Dropbox Configuration .


Google Drive API Integration

Before you can create a Google Drive extranet definition, your Google Drive administrator will need to generate Google API credentials for the PentagonDocs Extranet Uploader. These credentials are required to grant access to your data from the Extranet Uploader.

To do this login to your Google account and navigate to the Google API console from this URL https://console.developers.google.com/projectcreate and Create a new Project

Enter an appropriate Project name, leave the Location field blank and then click Create

If you see this Notification icon spinning in the top right, click it to see information about the project creation:

Your project should now be created, select it in the top left if not

From the Dashboard click 'Go to APIs overview'

Then from the side menu, choose the Library, https://console.developers.google.com/apis/library

Select the Google Drive API

Enable the Google Drive API (again, check for Notifications popup)

From the side panel menu click Credentials then Configure Consent Screen, https://console.developers.google.com/apis/credentials/consent

Select External and click Create

Populate the required fields for Edit app registration

And:

Then click Save and Continue

Then back to the left side menu, click Credentials, then Create Credentials, then OAuth Client ID, https://console.developers.google.com/apis/credentials/oauthclient

Choose application type as Desktop app, choose a Name, then click Create

The Client ID and Client Secret will be displayed.

Copy these details, as they are required for the next step: Google Drive Configuration .

Click OAuth consent screen, then Publish App, then Confirm

NOTE: Ensure that you copy these credentials as they are required for the PentagonDocs Assistant google drive integration to function.


SharePoint Online Integration

No pre-configuration setup is required for SharePoint Online.

Please continue to the SharePoint Online Configuration page to get started


Viewpoint For Projects Integration

Configuration ›› Integration Configuration ››

Viewpoint For Projects Integration

Before you can create a Viewpoint For Projects extranet definition, you or your Viewpoint administrator will need to generate a Secret Key for the PentagonDOCS Extranet Uploader. This is required to grant access to your data from the Extranet Uploader.

To do this, login in to your Viewpoint For Projects and navigate to 'Personal Settings'.

Click 'Generate or View Secret Key'.

Enter your password and click 'OK'.

Copy the secret key as it is required for the next step: Viewpoint For Projects Configuration .


WeTransfer Integration

No pre-configuration setup is required for WeTransfer.

Please continue to the WeTransfer Configuration page to get started


Extranet Definitions

Extranet definitions are configurations used to allow the upload of files to a supported provider. Extranet definitions are defined per project, allowing each project to have multiple definitions to multiple providers. More than one definition for each provider can be created per project, this is useful if you want to upload to different locations within the target extranet site.

To create a new extranet definition, select a project object and then select the Extranet tab. On the Extranet page, select the gear icon to 'Configure Extranet Definitions'.

This displays the extranet definitions for the selected project.

A new definition can be created by selecting the 'New Definition' menu item, then selecting one of the supported providers.

Depending on the the provider selected, a new dialogue box is displayed with provider specific configuration. Please see the relevant sections for specific provider configuration.

Existing definitions can be edited or removed by right-clicking on the definition. Definitions can also be edited by double-clicking on a definition.

The Help menu is used to show this help file, or display version information in the About box.

Also See

Adoddle (Asite) Configuration

Autodesk BIM 360 Configuration

Dropbox Configuration

Google Drive Configuration

SharePoint Online Configuration

Viewpoint for Projects Configuration

WeTransfer Configuration


Asite Adoddle Configuration

To configure an Adoddle extranet definition, add an 'Asite Adoddle' definition to a project as detailed in the parent topic.

The 'Asite Adoddle Configuration' dialogue box is displayed.

Specify a Name for the definition, this is the name displayed to the user when requesting an upload.

Enter your login details and password, then click the 'Login' button.

If you do not have an Adoddle account or have trouble logging in, please contact Asite .

NOTE: Your Asite account will need to be granted API access before you can login. Please see Known Issues and Limitations for more details.

Upon successful login, select a project from the drop-down menu and select a target folder for upload.

Adoddle has a number of meta data properties that can be populated during upload. These Adoddle properties can be mapped to M-Files properties.

To do this, select the 'Property Mapping' tab in the 'Asite Adoddle Configuration' dialogue box.

Select the Adoddle property you want to map and click the 'Assign Mapping' button.

This will display the 'Assign Mapping' dialogue box. Mappings can be made using both direct and indirect properties defined within the selected vault.

NOTE: Direct properties are those directly associated with the Class the document belongs to, these are displayed as root nodes in the property tree. Indirect properties are from linked objects and sub-objects, these are displayed as child nodes in the property tree.

Select a property from the M-Files property tree, then click 'Add' to assign the mapping to the chosen Adoddle property.

To remove a mapping, select the Adoddle property from the list and click the 'Remove Mapping' button.

You must assign mappings to the Adoddle properties marked at required.

Once you have completed the configuration, click 'OK' to add the extranet definition to the project.


Autodesk BIM 360 Configuration

Autodesk BIM 360 Docs Configuration

The BIM 360 Docs extranet provider also supports Autodesk A360 Team.

To configure a BIM 360 Docs extranet definition,

1) Configure the integration as detailed here

2) Add an Autodesk BIM 360 Docs definition to a project as detailed in the parent topic.

The 'Autodesk BIM 360 Docs Configuration' dialogue box is displayed.

Specify a Name for the definition, this is the name displayed to the user when requesting an upload.

You must then authenticate by clicking the 'Authenticate' button.

NOTE: The PentagonDocs Assistant 'custom integration' will need to be added to your BIM 360 site before you can create an extranet definition.

The Authenticate button redirects you to the Autodesk website, where you need to enter you credentials and authorise the application.

Once authenticated, you can click the browse button to select a destination folder. This displays the 'Browse Destination' dialogue box.

This allows you to navigate the structure in BIM 360 Docs, then select the upload destination folder.

Click 'OK' to set the destination folder.

Once you have completed the configuration, click 'OK' to add the extranet definition to the project.

Also See

Autodesk BIM 360 Custom Integration


Dropbox Configuration

To configure a Dropbox extranet definition,

1) Configure the integration as detailed here

2) Add an 'Dropbox' definition to a project as detailed in the parent topic

The 'Dropbox Configuration' dialogue box is displayed.

Specify a Name for the definition, this is the name displayed to the user when requesting an upload.

Enter your Dropbox Access Token, then click the 'Login' button. If you do not have your Dropbox Access Token, details on how to generate these can be found in the Dropbox API Integration topic.

Once you have successfully logged in you can select a target folder for upload.

Once you have completed the configuration, click 'OK' to add the extranet definition to the project.

Also See

Dropbox API Integration topic


Google Drive Configuration

To configure a Google Drive extranet definition,

1) Configure the integration as detailed here

2) Add an 'Google Drive' definition to a project as detailed in the parent topic

The 'Google Drive Configuration' dialogue box is displayed.

Specify a Name for the definition, this is the name displayed to the user when requesting an upload.

Enter your Google Drive API Client ID and Client Secret details, then click the 'Login' button. If you do not have your Google Drive API Client ID or Client Secret, details on how to generate these can be found in the Google Drive API Integration topic.

Once you click Login, it will open a browser window and ask you to log into your Google account

It will then give this message:

Click Advanced

Then click 'Go to your app name (unsafe)'

Grant the app permissions by clicking Allow on these screens:

Once you have successfully logged in you can select a target folder for upload.

Once you have completed the configuration, click 'OK' to add the extranet definition to the project.

Also See

Google Drive API Integration


SharePoint Online Configuration

To configure an SharePoint Online extranet definition, add an 'SharePoint Online' definition to a project as detailed in the parent topic.

The 'SharePoint Online' dialogue box is displayed.

Specify a Name for the definition, this is the name displayed to the user when requesting an upload.

Enter the SharePoint Site URL, your username and password and click Login

Once you have logged successfully logged in you can select a target folder

Once you have completed the configuration, click 'OK' to add the extranet definition to the project.


Viewpoint For Projects Configuration

To add a Viewpoint For Projects extranet definition,

1) Configure the integration as detailed here

2) Add a 'Viewpoint For Projects' definition to a project as detailed in the parent topic

The 'Viewpoint Configuration' dialogue box is displayed.

Specify a Name for the definition, this is the name displayed to the user when requesting an upload.

Enter your Viewpoint Login/Email address, Password and your Secret Key in the General tab.

If you do not have your Secret Key, details on how to generate these can be found in the Viewpoint For Projects Integration topic

You may also need to provide the API Key and API URL, in the Advanced tab

Then click Login, on the General tab

Once you have successfully logged in you can select a target container for upload.

Optional: tick the box for Upload as registered document

This will add an additional Registered Document tab where you can select more options depending on your requirements

Once you have completed the configuration, click 'OK' to add the extranet definition to the project.

Also See

Viewpoint For Projects API Integration topic


WeTransfer Configuration

To configure an WeTransfer extranet definition, add an 'WeTransfer' definition to a project as detailed in the parent topic.

The 'WeTransfer' dialogue box is displayed.

Specify a Name for the definition, this is the name displayed to the user when requesting an upload, there is no destination to set.

Once you have completed the configuration, click 'OK' to add the extranet definition to the project.

When uploading files, it will generate WeTransfer links for the uploaded files. These can be found from the Extranet tab on the file, or on the Project.

Please note that WeTransfer links will be created for individual files. If you have a collection of files to send, it may be preferred to combine them in a .zip file first.


Creating an Upload Request

To create an upload request, select one or more Document Objects or Files from within the M-Files desktop client application. Then click on the 'Upload' menu item in the Task Area.

The 'Extranet Upload Request' dialogue box is displayed. Extranet definitions for the current project are shown on the left of the interface.

NOTE: The current project is determined by meta data from the first selected document or file.

On the right of the interface the selected files are displayed. When Multi-file Document objects (MFD) are selected, all files contained within the MFD object are included.

Multiple documents can be added by selecting a document collection object. For PentagonDocs Assitant customers, referenced documents are included when selecting a Transmittal.

Files with a check mark will be included in the upload request. Files can be manually included or excluded by clicking the check boxes against each file.

Alternatively, files can be included or excluded by file type using the drop-down filter.

When selecting documents or files with differing projects, a warning is displayed. Files not associated with the current project are displayed in grey, the system does not prevent you from including these files in the upload request.

NOTE: Files of checked out objects cannot be selected for inclusion in the upload request. This is due the to file not being available on the server until it is checked-in.

When the extranet definition is set and one or more files checked, the 'Submit Upload Request' button is enabled. Clicking the submit button logs the request with the server.

The total number of files in the current request is shown next to the submit button. The 'Open Log after Request' check box determines whether a pop-out log window is displayed upon completion.

Also See

Supported Providers


Project Log

The project log is available by selecting the 'Extranet' tab on a project object. The project log shows all uploads associated with the selected project.

Tool Buttons

Pop-out Log Window

Pops out the current project log into a separate window.

Configure Extranet Definitions

Opens the interface where extranet definitions can be created, edited or deleted.

Help

Views this help file.

The log header gives details of the selected project name, ID and Version. Log items are listed with details of the extranet definition, filename, status and request date.

Each file in the project log has a status icon and description, please see Log Management for more details.

The [image] icon can be used to open a pop-out window showing the specific version of the file.

Double-clicking on an upload request, opens the 'Request Details' dialogue box.

The log can be searched using the search box in the toolbar.

NOTE: Only the metadata displayed in the log is used for the search feature. Metadata from the associated objects is not taken into account.

Also See

Creating an Upload Request

Document Log


Document Log

The document log is available by selecting the 'Extranet' tab on a document object. The document log shows all uploads associated with the selected document.

Tool Buttons

Help

Views this help file.

The log header gives details of the selected document name, ID and Version. Log items are listed with details of the extranet definition, filename, version, status and request date.

Each file in the document log has a status icon and description, please see Log Management for more details.

The [image] icon can be used to open a pop-out window showing the specific version of the file.

Double-clicking on an upload request, opens the 'Request Details' dialogue box.

By default, the document log only shows the upload requests for the selected version.

To view the upload request for all versions, use the version filter as shown below. The version column shows the version number of the historic upload requests.

The log can be searched using the search box in the toolbar.

NOTE: Only the metadata displayed in the log is used for the search feature. Metadata from the associated objects is not taken into account.

Also See

Creating an Upload Request

Project Log


Log Management

Each upload request shown in the in the project or document log has status icon and description.

Upload requests can have one of the four statuses as defined below.

Status Icons

Queued

The uploaded request is in a queue and waiting to be processed.

In Progress

The upload request is currently being processed. Upload requests are processed sequentially in the order in which there were requested.

Successful

The upload request has completed successfully.

Failed

The upload request has failed. Refer to the Request Details to identify the reason for failure.

Queue Functions

The last column of the log provides functions that can be used to manage log items depending on their status.

The available functions are listed below.

Retry Request

Retries an upload request. Only failed upload requests can be retied.

Delete Request

Deletes an uploaded request from the log. Upload requests can only be deleted while in the Queued state. Once a request has begun processing, it can no longer be deleted.

NOTE: Extranet definitions are versioned, with requests linked to the definition version they were created with. Because of this retrying failed requests may consistently fail if the historic extranet definition is no longer valid. i.e. password has changed.

Also See

Creating an Upload Request

Project Log

Document Log


Request Details

Double-clicking on an item in the project or document queue shows detailed information about that upload request.

Upload Status, Error and Error Details are useful when diagnosing upload failures.

Where supported External URL links to the uploaded files are provided. Clicking on the link opens a browser window with the external link.

The link can be copied to the clipboard by selecting the [image] icon.

Also See

Creating an Upload Request

Project Log

Document Log


Support

Extranet Uploader for M-Files

For support related to the installation and or usage of this Application, please contact:

Pentagon Solutions
Suite 3
Teal Pavilion
Portside Business Park
189 Airport Road West
Belfast, Northern Ireland
BT3 9ED

Pentagon Support

T: 02890455355
E: support @pentagonsolutions.com
www.pentagonsolutions.com